data <- read.csv("data.public.csv")
attach(data)

# Variable Names

# year  
# month
# GDP (quarterly)
# UNEMPLOYALL = unemployment rate
# SAMP = the number of respondents

# NEWSCHIN = the number of reports about China
# NEWSKR = the number of reports about Korea
# NEWSNK = the number of reports about North Korea

# CHINASA = the more accurate number of reports about China on Asahi newspaper
# CHINYOMI = the more accurate number of reports about China on Yomiuri newspaper
# CHIMAI = the more accurate number of reports about China on Asahi newspaper

# CHINAE = Export to China 
# CHINAI = Import from China
# RKOREAE = Export to Korea
# RKOREAI = Import from Korea
# NKOREAE = Export to North Korea
# NKOREAI = Import from North Korea

source("functions.r")

# make variables

time <- 1900+year+(month-1)/12
econ <- UNEMPLOYALL
log.sample.size <- log(SAMP)
use.news <- ((time>=(1960+((5-1)/12)))&(time<2011))

china.news <- NEWSCHIN
china.trade.gdp <- (CHINAE*1000 + CHINAI*1000)*100/((GDP*(10^9))/3)
china.gap <- (CHINAE - CHINAI)*100/((GDP*(10^6))/3)

korea.news <- NEWSKR
korea.trade.gdp <- (RKOREAE*1000 + RKOREAI*1000)*100/((GDP*(10^9))/3)
korea.gap <- (RKOREAE - RKOREAI)*100/((GDP*(10^6))/3)

NK.news <- NEWSNK
NK.trade.gdp <- (NKOREAE*1000 + NKOREAI*1000)*100/((GDP*(10^9))/3)
NK.gap <- (NKOREAE - NKOREAI)*100/((GDP*(10^6))/3)

# make figures

source("figures.without.jiji.r")

# measurement error?
cor(na.omit(cbind(NEWSCHIN,CHINASA)))
cor(na.omit(cbind(NEWSCHIN,CHINYOMI)))
cor(na.omit(cbind(NEWSCHIN,CHIMAI)))