mylag <- function(x){
x <- as.matrix(x)
obs <- nrow(x)
k <- ncol(x)
lag.x <- matrix(NA, obs, k)
for (i in 2:obs){lag.x[i,] <- x[i-1,] 
 }
lag.x
}

mydif <- function(x){
x-mylag(x)
}

logodds <- function(x){log(x/(1-x))}

logit <- function(x){1/(1+exp(-x))}

significance <- function(x){
ifelse(x<0.01,1,ifelse(x<0.05,5,0))
}

ecm <- function(formula.short, formula.long, formula.hetero, n, llik, ...){
# extract variables
  model <- model.frame(formula.short)
    y <- model.extract(model, "response")
    y <- as.matrix(y)
    y.lag <- mylag(y)[-1,]
    y <- y[-1,]
    obs <- length(y)
  x1 <- as.matrix(model.matrix(formula.short))#[-1,]
  x1 <- mydif(x1)[-1,]#
  x1[,1] <- c(rep(1, obs))#
   colnames(x1)[1] <- c("beta0")#
  x2 <- as.matrix(model.matrix(formula.long))
name2 <- paste("l",colnames(x2))[-1]
    x2 <- mylag(x2)[-1,-1]
  x <- cbind(x1, x2) 
    k <- ncol(x)
  z <- as.matrix(model.matrix(formula.hetero))[-1,]
    colnames(z)[1] <- "eta0"
    k2 <- ncol(z)
n <- n[-1]
# optimization
x.start <- cbind(x[,-1], y.lag)
start <- glm(y ~ x.start, family=gaussian)$coefficients
res <- optim(c(start, rep(0, k2)), llik, method = "BFGS",
  hessian = TRUE, control = list(fnscale = -1),
  y = y, y.lag=y.lag, x = x, z = z, n = n)
  names(res$par) <- c(colnames(x),"delta", colnames(z))
  names(res$par) <- c(paste("s",colnames(x1)),name2,"delta",paste("v",colnames(z)))
beta <- res$par[1:k]
delta <- res$par[k+1]
eta <- res$par[(k+2):(k+k2+1)]
mu <- (x%*%beta)+(y.lag*delta)
sigma2 <- exp(z%*%eta)
  res$mu <- mu
  res$sigma2 <- sigma2
  res$y <- y
res
}

llik.normal <- function(par, y, y.lag, x, z, n){
# set up
k <- ncol(x); k2 <- ncol(z)
# extract parameters
beta <- par[1:k]
delta <- par[k+1]
eta <- par[(k+2):(k+k2+1)]
mu <- (x%*%beta)+(y.lag*delta)
sigma2 <- exp(z%*%eta)
sum(-(log(2*pi*sigma2)/2)-(((y-mu)^2)/(2*sigma2)))# plus or minus
}

report <- function(out){
se <- sqrt(diag(-solve(out$hessian)))
z0 <- out$par/se
p0 <- 2*(0.5-abs(pnorm(z0)-0.5))
star <- significance(p0)
res <- round(cbind(out$par, se,  z0, p0,star),3)
res
}

